TileDrawer = {}

function TileDrawer:init()
	self.tileTextureAtlas = love.graphics.newImage("res/gfx/tile_atlas.png")
	self.tileTextureAtlas:setFilter("nearest", "nearest")
	self.tileTextureBatch = love.graphics.newSpriteBatch(
		self.tileTextureAtlas,
		(math.floor(DRAW_WIDTH / TILE_SIZE) * math.floor(DRAW_HEIGHT / TILE_SIZE))
	)
end

function TileDrawer:preRegister()
	self.tileTextureBatch:bind()
	self.tileTextureBatch:clear()
end

function TileDrawer:postRegister()
	self.tileTextureBatch:unbind()
end

function TileDrawer:draw()
	love.graphics.draw(self.tileTextureBatch)
end

function TileDrawer:registerTile(tileInstance)
	if tileInstance.id == TILE_AIR then
		return
	end

	self.tileTextureBatch:add(
		TileDictionary:getDefinitionOf(tileInstance.id).quad,
		tileInstance.x,
		tileInstance.y
	)
end

function TileDrawer:getAtlasWidth()
	return self.tileTextureAtlas:getWidth()
end

function TileDrawer:getAtlasHeight()
	return self.tileTextureAtlas:getHeight()
end